#ifndef Control_H_
#define Control_H_
#include <Arduino.h>
#include "Ch.h"

class Control {
  protected:
    uint8_t pin;
    Ch * ch;

  public:
    Control();
    virtual void setPin(uint8_t p);
    void setCh(Ch *c) { ch = c;} 
    virtual void handle() = 0;
};

class AnalogControl  : public Control {
private:
    
public:
    virtual void setPin(uint8_t p);  
    virtual void handle();
    void resetCenterAnalog();
    boolean resetPercent();
};


class BtnControl  : public Control {
protected:
    virtual bool isTriggered();
public:

    virtual void setPin(uint8_t p);    
    virtual void handle() = 0;
};

class FuncBtnControl  : public BtnControl {
private:
   void (*func)();
public:
    virtual void handle();
    void setFunc(void (*f)())  { func = f; }
};

class OffsetBtnControl  : public BtnControl {
private:
   bool dec;
   void (*longPressFunc)();
public:
    OffsetBtnControl();
    virtual void handle();

    void setDec(bool b) { dec = b; }
    virtual bool isTriggered();
 };

class ReverseBtnControl  : public BtnControl {
private:

public:

    virtual void handle();
    
 };

#ifdef BAT_ALART
class BatAlertControl  : public Control {
private:
    
public:
    virtual void handle();
};
#endif

#ifdef TEST_CHAN
class TestControl  : public Control {
public:
    TestControl();
    void handle();
};
#endif

#endif
